package org.droidfoot.dfsnake;

import greenfoot.Greenfoot;
import greenfoot.World;

// (World, Actor, GreenfootImage, and Greenfoot)

/**
 * Well knoe worm game
 * 
 * @author Dietrich Boles
 * @version 1.0
 */
public class WormWorld extends World {

	public WormWorld() {
		this(20, 20);
	}

	public WormWorld(int columns, int rows) {
		super(columns, rows, 30);
		setBackground("tile.gif");
		Greenfoot.setSpeed(30);
		setPaintOrder(ScoreBoard.class, Head.class, Body.class, Apple.class);
		setActOrder(Body.class, Head.class);
		generateTerritory();
	}

	public void started() {

	}

	public void generateTerritory() {
		Head head = new Head();
		addObject(head, getWidth() / 2, getHeight() / 2);
		genApple();
		Body.reset();
	}

	public void genApple() {
		Apple apple = new Apple();
		int x = Greenfoot.getRandomNumber(getWidth());
		int y = Greenfoot.getRandomNumber(getHeight());
		while (this.getObjectsAt(x, y, null).size() > 0) { // occupied
			x = Greenfoot.getRandomNumber(getWidth());
			y = Greenfoot.getRandomNumber(getHeight());
		}
		addObject(apple, x, y);
	}

	public void gameOver() {
		Greenfoot.playSound("bombe.wav");
		addObject(new ScoreBoard(Body.getNumberOfBodies()), getWidth() / 2,
				getHeight() / 2);
		Greenfoot.stop();
	}

}
